// crpr.cpp : Hrani si s CreateProcess

#include <windows.h>
#include <stdio.h>
#include <tchar.h>
#include <conio.h>

void main()
{

/****************** Pozice okna nove spusteneho programu (doporuceni) ******************************/

STARTUPINFO si;
PROCESS_INFORMATION pi;
ZeroMemory( &si, sizeof(si) );
si.cb = sizeof(si);
si.dwX = GetSystemMetrics(SM_CXFULLSCREEN) / 2;
si.dwY = GetSystemMetrics(SM_CYFULLSCREEN) / 2;
si.dwFlags= STARTF_USEPOSITION;
ZeroMemory( &pi, sizeof(pi) );

if(!CreateProcess(L"c:\\windows\\system32\\sol.exe", NULL, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi))
{
	printf( "CreateProcess2 failed (%d)\n", GetLastError() );
	getch();
	return;
}
WaitForSingleObject( pi.hProcess, INFINITE );
CloseHandle( pi.hProcess );
CloseHandle( pi.hThread );

/*********************** Spusteni konzoloveho programu v nove konzoli ***********************************/

STARTUPINFO si3;
PROCESS_INFORMATION pi3;
ZeroMemory( &si3, sizeof(si3) );
si3.cb = sizeof(si3);
ZeroMemory( &pi3, sizeof(pi3) );

if(!CreateProcess(L"c:\\windows\\system32\\tree.com", L"tree c:\\windows", NULL, NULL, TRUE, CREATE_NEW_CONSOLE, NULL, NULL, &si3, &pi3))
{
	printf( "CreateProcess failed (%d)\n", GetLastError() );
	getch();
	return;
}
WaitForSingleObject( pi3.hProcess, INFINITE );
CloseHandle( pi3.hProcess );
CloseHandle( pi3.hThread );

/*********************** Presmerovani vystupu konzoloveho programu do souboru ****************************/

SECURITY_ATTRIBUTES sa;
sa.nLength = sizeof(SECURITY_ATTRIBUTES);
sa.lpSecurityDescriptor = 0;
sa.bInheritHandle=TRUE;
HANDLE sample = CreateFile(L"out.txt", GENERIC_WRITE,0, &sa, CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL, 0);
if(sample == INVALID_HANDLE_VALUE)
{
	printf( "CreateFile failed (%d)\n", GetLastError() );
	getch();
	return;
}

STARTUPINFO si2;
PROCESS_INFORMATION pi2;
ZeroMemory( &si2, sizeof(si2) );
si2.cb = sizeof(si2);
si2.hStdOutput=sample;
si2.hStdError=sample;
//si2.hStdInput=sample;
si2.dwFlags=STARTF_USESTDHANDLES;
ZeroMemory( &pi2, sizeof(pi2) );

if(!CreateProcess(L"c:\\windows\\system32\\tree.com", L"tree c:\\windows", NULL, NULL, TRUE, 0, NULL, NULL, &si2, &pi2))
{
printf( "CreateProcess failed (%d)\n", GetLastError() );
getch();
return;
}
WaitForSingleObject( pi2.hProcess, INFINITE );
CloseHandle( pi2.hProcess );
CloseHandle( pi2.hThread );

/*********************** Dedeni otevreneho deskriptoru (prenos pres textovy parametr) *********************/

SECURITY_ATTRIBUTES sa4;
sa4.nLength = sizeof(SECURITY_ATTRIBUTES);
sa4.lpSecurityDescriptor = 0;
sa4.bInheritHandle=TRUE;

HANDLE sample4 = CreateFile(L"in.txt", GENERIC_READ,0, &sa4, OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL, 0);
if(sample4 == INVALID_HANDLE_VALUE)
{
	printf( "CreateFile failed (%d)\n", GetLastError() );
	getch();
	return;
}

WCHAR s4[100];
swprintf(s4,L"b.exe %lu",(unsigned long)sample4);

STARTUPINFO si4;
PROCESS_INFORMATION pi4;
ZeroMemory( &si4, sizeof(si4) );
si4.cb = sizeof(si4);
ZeroMemory( &pi4, sizeof(pi4) );

if(!CreateProcess(L"b.exe", s4, NULL, NULL, TRUE, 0, NULL, NULL, &si4, &pi4))
{
	printf( "CreateProcess failed (%d)\n", GetLastError() );
	getch();
	return;
}
WaitForSingleObject( pi4.hProcess, INFINITE );
CloseHandle( pi4.hProcess );
CloseHandle( pi4.hThread );
}
